Subject: Re: Gerrit, GitButler, and Jujutsu projects collaborating on change-id commit footer

From: Nico Williams <[email-masked]>
Date: Fri, 4 Apr 2025 11:08:00 -0500

On Fri, Apr 04, 2025 at 09:41:24AM +0200, Remo Senekowitsch wrote:
> I'll try to join some of our threads and summarize... please correct me
> if you disagree with that summary (or I've left something out you think
> is important).
>
> [...]

+1.

> When discussing the uniqueness of change-ids or lack thereof, I'd
> like to introduce one more factor: At which point in time during the
> development cycle a change-id is unique. Jujutsu users derive most
> of the benefits of change-ids during active development. The use case
> you find most important - tracking (forward- and) back-ports - happens
> at a different time during development, when a change has been merged
> to a public branch already. So I think there is no conflict at all.
> Change-ids will naturally tend to be unique during active development
> and once they are merged, whether the change-id stays unique or not
> doesn't matter anymore for those active development use cases. We can
> have our cake and eat it too.

I think that's right.  One more benefit of change IDs is that you can
find a commit in a back-/forward-port and track it all the way to its
very initial integration and its code review history, perhaps all the
way to its very first version.